Subject: bug#14029: closed (Re: bug#14029: 24.2.50; [PATCH] imenu problems with special elements)

From: [email-masked] (GNU bug Tracking System)
Date: Fri, 29 Nov 2013 03:45:04 +0000

Your bug report

#14029: 24.2.50; [PATCH] imenu problems with special elements 

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
14029: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=14029
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#14029: 24.2.50; [PATCH] imenu problems with special elements
From: Dmitry Gutov <[email-masked]>
To: Andreas Politz <[email-masked]>
Cc: [email-masked]
Date: Fri, 29 Nov 2013 05:43:57 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

Version: 24.4

Thanks, that's clearer. Installed in revision 115279.

One note:

 >> Is it possible for (cadr item) to be a list and also be `functionp' 
and yet not
 >> have its car be `lambda'?  Dunno.  I was under the impression that 
it was
 >> impossible, but I could be wrong.  If it is possible, is it better 
to test
 >> `functionp' here?  Dunno.
 >
 > If the documentation states FUNCTION, then it should be a function.

The documentation allows FUNCTION in the third element, but 
`imenu--subalist-p' is checking whether the second element is a function.

AFAICT, it's checking against malformed items. Your change makes it also 
guard against lexically-bound lambdas (their car is `closure'), so 
that's good, I guess.

Subject: 24.2.50; [PATCH] imenu problems with special elements
From: Andreas Politz <[email-masked]>
To: [email-masked]
Date: Fri, 22 Mar 2013 02:24:33 +0100
List-Id: <debbugs-submit.debbugs.gnu.org>

,----[ (info "(elisp) Imenu") ]
| Special elements look like this:
| 
|           (INDEX-NAME INDEX-POSITION FUNCTION ARGUMENTS...)
| 
|      Selecting a special element performs:
| 
|           (funcall FUNCTION
|                    INDEX-NAME INDEX-POSITION ARGUMENTS...)
`----

1. At least one function does not recognize these elements, resulting
in an error.

2. The advertised calling convention is different from the actual one in
`imenu'.

3. The `imenu--subalist-p' predicate is unsafe and incomplete.

Andreas

diff -c -L /home/politza/src/emacs/trunk/lisp/imenu.el -L \#\<buffer\ imenu.el\> /home/politza/src/emacs/trunk/lisp/imenu.el /tmp/buffer-content-3095O-q
*** /home/politza/src/emacs/trunk/lisp/imenu.el
--- #<buffer imenu.el>
***************
*** 286,293 ****

  (defun imenu--subalist-p (item)
!   (and (consp (cdr item)) (listp (cadr item))
!        (not (eq (car (cadr item)) 'lambda))))
  
  (defmacro imenu-progress-message (_prevpos &optional _relpos _reverse)
    "Macro to display a progress message.
--- 286,295 ----

  (defun imenu--subalist-p (item)
!   (and (consp item)
!        (consp (cdr item))
!        (listp (cadr item))
!        (not (functionp (cadr item)))))
  
  (defmacro imenu-progress-message (_prevpos &optional _relpos _reverse)
    "Macro to display a progress message.
***************
*** 641,647 ****
        ;; We are only interested in the bottom-level elements, so we need to
        ;; recurse if TAIL is a list.
        (cond ((listp tail)
! 	     (if (setq res (imenu--in-alist str tail))
  		 (setq alist nil)))
  	    ((if imenu-name-lookup-function
                   (funcall imenu-name-lookup-function str head)
--- 643,650 ----
        ;; We are only interested in the bottom-level elements, so we need to
        ;; recurse if TAIL is a list.
        (cond ((listp tail)
! 	     (if (and (imenu--subalist-p elt)
!                       (setq res (imenu--in-alist str tail)))
  		 (setq alist nil)))
  	    ((if imenu-name-lookup-function
                   (funcall imenu-name-lookup-function str head)
***************
*** 1024,1030 ****
  		(nth 2 index-item) imenu-default-goto-function))
  	   (position (if is-special-item
  			 (cadr index-item) (cdr index-item)))
! 	   (rest (if is-special-item (cddr index-item))))
        (apply function (car index-item) position rest))
      (run-hooks 'imenu-after-jump-hook)))
  
--- 1027,1033 ----
  		(nth 2 index-item) imenu-default-goto-function))
  	   (position (if is-special-item
  			 (cadr index-item) (cdr index-item)))
! 	   (rest (if is-special-item (cdddr index-item))))
        (apply function (car index-item) position rest))
      (run-hooks 'imenu-after-jump-hook)))

Diff finished.  Fri Mar 22 02:15:09 2013